网站导航免费论文 原创论文 论文搜索 原创论文 网学软件 学术大家 资料中心 会员中心 问题解答 原创论文 论文素材 设计下载 最新论文 下载排行 论文上传 在线投稿 联系我们
返回网学首页
网学联系
最新论文 推荐专题 热门论文 素材专题
当前位置: 网学 > 编程文档 > C# > 正文
SmartSoft中用C#.Net实现AutoCAD块属性提取
来源:Http://myeducs.cn 联系QQ:点击这里给我发消息 作者: 用户投稿 来源: 网络 发布时间: 12/10/14
下载{$ArticleTitle}原创论文样式
eID ="ObjectDBX.AxDbDocument.17"; 
  AutoCAD.AcadApplication AcadApp = Connector.Application; 
  dbx.AxDbDocument dbxDoc; 
  dbxDoc=(dbx.AxDbDocument)AcadApp.GetInterfaceObject(programeID); 
  try 
  { 
  if (System.IO.File.Exists (FileName)==false) throw new Exception ("文件不存在。"); 
  dbxDoc.Open(FileName,PassWord); 
  }// end of try 
  catch (Exception e) 
  { 
  System.Windows.Forms.MessageBox.Show(e.Message ); 
  dbxDoc=null; 
  } 
  return dbxDoc; 
  }//end of function GetThisDrawing 
  ///  
  /// 根据当前文档和块名取得当前块的引用 
  ///  
  public dbx.AcadBlockReference GetBlockReference(dbx.AxDbDocument thisDrawing,string blkName) 
  { 
  dbx.AcadBlockReference blkRef=null; 
  bool found = false; 
  try 
  { 
  foreach (dbx.AcadEntity entity in thisDrawing.ModelSpace ) 
  { 
  if (entity.EntityName=="AcDbBlockReference") 
  { 
  blkRef=(dbx.AcadBlockReference)entity; 
  //System.Windows.Forms.MessageBox.Show(blkRef.Name); 
  if (blkRef.Name.ToLower() ==blkName.ToLower() ) 
  { 
  found = true; 
  break; 
  } 
  }//end of entity.EntityName=="AcDbBlockReference" 
  }// end of foreach thisDrawing.ModelSpace 
  }//end of try 
  catch (Exception e) 
  { 
  System.Windows.Forms.MessageBox.Show ("图形中有未知的错误,格式不正确或图形数据库需要修愎。系统错误提示:" + e.Message ,"信息",System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Warning); 
  thisDrawing=null; 
  }//end of catch 
  if (!found) blkRef = null; 
  return blkRef; 
  }//end of function GetBlockReference 
  ///  
  /// 根据给定的块引用(dbx.AcadBlockReference)和属性名返回属性值 
  ///  
  public object GetValueByAttributeName(dbx.AcadBlockReference blkRef,string AttributeName) 
  { 
  object Atts=(object)blkRef.GetAttributes(); 
  object attValue=null; 
  for (int i=0;i  
  { 
  dbx.AcadAttributeReference attRef; 
  attRef=(dbx.AcadAttributeReference)Atts[i]; 
  if (attRef.TagString==AttributeName) 
  { 
  attValue= attRef.TextString ; 
  break; 
  } 
  }//end of for i 
  return attValue; 
  }// end of function 
  #endregion 
  }//end of cla

网学推荐

免费论文

原创论文

浏览:
设为首页 | 加入收藏 | 论文首页 | 论文专题 | 设计下载 | 网学软件 | 论文模板 | 论文资源 | 程序设计 | 关于网学 | 站内搜索 | 网学留言 | 友情链接 | 资料中心
版权所有 QQ:3710167 邮箱:3710167@qq.com 网学网 [Myeducs.cn] 您电脑的分辨率是 像素
Copyright 2008-2015 myeducs.Cn www.myeducs.Cn All Rights Reserved
湘ICP备09003080号